SHEBANG
# Copyright (C)2003..2018 @BABOLO http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up.m4,v 1.3 2018/06/05 17:16:27 babolo Exp $

JNTROSTUP(apache24,,dnl
,dnl
# jailup ${genclass}${suffix} dir jailname jailaddr[ user[ group[ port]]]
#     where dir relative to ${JAILUPDIR} and ${JAILRODIR}
#     default user=0, default group=0, default port=80
# installed ports/www/apache24 useddnl
,TESTADMINdnl
)

jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
user="${4:-0}"
group="${5:-0}"
port="${6:-80}"
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"

${mkdir} "${main_dir}" "${conf_dir}/apache24/extra"
${up_mdir} "${main_dir}" "${MTREE}"
WWWCOPY(icons/small)
WWWCOPY(icons)
WWWCOPY(error/include)
WWWCOPY(error)
ETCOPY(host.conf hosts protocols resolv.conf)
${up_conf} "${conf_dir}/apache24/" ${PREFIX}/etc/apache24/ << "EOF"
    magic
    mime.types
    server.crt
    server.key
    server-ca.crt
EOF

${up_conf} "${conf_dir}/apache24/extra/" ${PREFIX}/etc/apache24/extra/ << "EOF"
    httpd-autoindex.conf
    httpd-dav.conf
    httpd-default.conf
    httpd-info.conf
    httpd-languages.conf
    httpd-manual.conf
    httpd-mpm.conf
    httpd-multilang-errordoc.conf
    httpd-ssl.conf
    httpd-userdir.conf
    httpd-vhosts.conf
    proxy-html.conf
EOF

${up_libexe} "${main_dir}/libexec" "${PREFIX}/libexec/apache24" << EOF
    ld-elf.so.1
    httpd
    `${up_genlist} libexec/ ${MTREE}`
EOF

for i in ${main_dir}/libexec/*
do
    echo "${i}"
done | ${up_ldsh} | ${up_shlib} "${main_dir}/lib"

      #####################################
      ####                             ####
      #### Begin of etc fill           ####
      ####                             ####
${up_acc} gr "${conf_dir}" <<- EOF
	wheel:*:0:root
	nogroup:*:65533:
	nobody:*:65534:
	www:*:80:
EOF

${up_acc} pwt "${conf_dir}" <<- EOF
	root:*:0:0::0:0:Charlie &:/:/dev/null/none
	nobody:*:65534:65534::0:0:Unprivileged user:/dev/null/none:/dev/null/none
	www:*:80:80::0:0:WWW:/www:/dev/null/none
EOF

CONFCOPY(apache24/apache.conf,  "${TEMPLATE}")
CONFCOPY(apache24/httpd.conf, "${TEMPLATE}"-httpd)
CONFCOPY(apache24/httpsd.conf, "${TEMPLATE}"-httpsd)

${up_adc} "${etcdir}/newsyslog.conf" <<- EOF
	#${main_dir}/var/log/hit 	644  9     *	@01T00  Z ${main_dir}/var/run/apache.pid
	#${main_dir}/var/log/err 	644  9     *	@01T00  Z ${main_dir}/var/run/apache.pid
	#${main_dir}/var/log/ssl 	644  9     *	@01T00  Z ${main_dir}/var/run/apache.pid
EOF
      ####                             ####
      #### End of etc fill             ####
      ####                             ####
      #####################################

${mtree} -Ueqxp "${main_dir}" -f ${MTREE}
${mtree} -Ueqxp "${conf_dir}" << "EOF"
/set type=file uname=root gname=wheel mode=0644 flags=none
.			type=dir mode=0755
    group
    host.conf
    hosts
    localtime
    master.passwd		mode=0600
    master.template		mode=0600
    protocols
    resolv.conf
    apache24			type=dir mode=0755
        apache.conf
        httpd.conf
        httpsd.conf
        magic
        mime.types
        server.crt
        server.key
        server-ca.crt
    ..
..
EOF
${pwd_mkdb} -d "${conf_dir}" -p "${conf_dir}/master.passwd"

${up_adc} "${JAILUPRC}" <<- EOF
	#${genclass}	${inclass}	${jdir}	${jailsname}	${jailsaddr}	0	${user}	${group}	${port}	${ADMINEMAIL}	apache
EOF

      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${up_adc} "${etcdir}/fstab" <<- EOF
	#devfs			${main_dir}/dev	devfs	rw		0 0
	#${conf_dir}		${main_dir}/etc	nullfs	ro,noexec	0 0
EOF
      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
